<?php defined('SYSPATH') || die('No direct script access.');

class Controller_Handler_Rating extends Controller_Handler
{
    /** @var  Model_Rating */
    protected $model;

    public function before() {
        parent::before();

        $this->user->checkAccess(User::RIGHTS_TEACHER);
        $this->model = new Model_Rating;
    }

    public function action_SetRate() {
        $this->post
            ->rule('recordBookID', 'digit')
            ->rule('disciplineID', 'digit')
            ->rule('submoduleID', 'digit')
            ->rule('rate', 'numeric')
            ->rule('rate', 'range', [':value', -1, 100]);
        if (!$this->post->check())
            throw new HTTP_Exception_400('Неверные параметры запроса SetRate!');

        $error = Model_Rating::SetRate(
            $this->user->TeacherID,
            $_POST['recordBookID'],
            $_POST['disciplineID'],
            $_POST['submoduleID'],
            $_POST['rate']
        );
        if (!is_null($error))
            throw HTTP_Exception::factory($error['code'], $error['message']);

        $this->response->body(json_encode([ 'success' => true ]));
    }

    public function action_SetExamPeriodOption() {
        $this->post
            ->rule('recordBookID', 'digit')
            ->rule('disciplineID', 'digit')
            ->rule('submoduleID', 'digit')
            ->rule('option', 'in_array', array(':value', array('null', 'absence', 'pass')));
        if (!$this->post->check())
            throw new HTTP_Exception_400('Неверные параметры запроса SetExamPeriodOption!');

        $error = Model_Rating::SetExamPeriodOption(
            $this->user->TeacherID,
            $_POST['recordBookID'],
            $_POST['disciplineID'],
            $_POST['submoduleID'],
            $_POST['option']
        );
        if (!is_null($error))
            throw HTTP_Exception::factory($error['code'], $error['message']);

        $this->response->body(json_encode([ 'success' => true ]));
    }
}
